#include<bits/stdc++.h>
using namespace std;
long long a, b, n, curr;
long long solve(long long a){
    long long b=0, c=1;
    if(a==0) return 9;
    while(a!=0){
        if(a%10==0) b+=c*9;
        else b+=c*(a%10-1);
        c*=10;
        a/=10;
    }
    return b%1000;
}
int main(){
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cin>>n>>a>>b;
    if(n==1){
        cout<<a;
        return 0;
    }else if(n==2){
        cout<<b;
        return 0;
    }
    for(int i=3; i<=n; i++){
        curr=a*b;
        curr=solve(curr);
        a=b;
        b=curr;
    }
    cout<<curr;
    return 0;
}
